﻿using GTPCorrgir;
using System;
using System.Configuration;
using System.Windows;


namespace GTPCorrgir
{

    public class Opciones
    {
        public enum LLM_a_Usar
        {
            OpenAI,
            Ollama,
            Groq
        }
        public enum modoDeUso
        {
            Corregir,
            Ortografia,
            Chat,
            Traducir_a_Ingles,
            Traducir_a_Italiano,
            Traducir_a_Espanol,
        }

        public Dictionary<LLM_a_Usar, string> nombreLLM = new Dictionary<LLM_a_Usar, string>
        {
        { Opciones.LLM_a_Usar.Ollama, "Ollama" },
        { Opciones.LLM_a_Usar.Groq, "Groq" },
        { Opciones.LLM_a_Usar.OpenAI, "OpenAI" },        
 
        };

        private static Opciones _instance;
        
        public static Opciones Instance
        {
            get
            {
                if (_instance == null)
                {
                    _instance = new Opciones();
                    _instance.LLM = LLM_a_Usar.OpenAI;
                    _instance.modo = modoDeUso.Corregir;
                }
                return _instance;
            }
        }

        public LLM_a_Usar LLM { get; set; }
        public modoDeUso modo { get; set; }

        public string nombreDeLLM() {
            return nombreLLM[LLM];
        }

        private Opciones() { }
    }


    public class Program
    {
        [STAThread]
        public static void Main(string[] args)
        {
            var application = new App();

            foreach (var arg in args)
            {
                if (arg.StartsWith("--"))
                {
                    // Procesa el argumento según tus necesidades
                    if (arg.Contains("Ollama"))
                        Opciones.Instance.LLM = Opciones.LLM_a_Usar.Ollama;
                    else if (arg.Contains("Groq"))
                        Opciones.Instance.LLM = Opciones.LLM_a_Usar.Groq;
                    else if (arg.Contains("OpenAI"))
                        Opciones.Instance.LLM = Opciones.LLM_a_Usar.OpenAI;

                    if (arg.Contains("Chat"))
                        Opciones.Instance.modo = Opciones.modoDeUso.Chat;
                    else if (arg.Contains("Ortografia"))
                        Opciones.Instance.modo = Opciones.modoDeUso.Ortografia;
                    else if (arg.Contains("Corregir"))
                        Opciones.Instance.modo = Opciones.modoDeUso.Corregir;
                    else if (arg.Contains("Traducir_a_Ingles"))
                        Opciones.Instance.modo = Opciones.modoDeUso.Traducir_a_Ingles;
                    else if (arg.Contains("Traducir_a_Italiano"))
                        Opciones.Instance.modo = Opciones.modoDeUso.Traducir_a_Italiano;
                    else if (arg.Contains("Traducir_a_Espanol"))
                        Opciones.Instance.modo = Opciones.modoDeUso.Traducir_a_Espanol;

                }
            }

            application.Run();
        }
    }

}



